/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_SETORPROD                                                */
/* Tabela : SETORPRODUTO                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 26/01/2016 - Joao Marcelo Alves Leao                                       */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
             o.name = 'DTULTATU_SETORPROD'   and
             type = 'TR'                     and
             u.uid = o.uid                   and
             u.name = USER)
DROP TRIGGER DTULTATU_SETORPROD
GO

CREATE TRIGGER DTULTATU_SETORPROD
ON SETORPRODUTO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'SETORPRODUTO', 'CDPRODUTO=' + CDPRODUTO +
                                     ';CDSETOR='+ CDSETOR+';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE SETORPRODUTO
      SET DTULTATU = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(SETORPRODUTO.CDPRODUTO,0) = ISNULL(INSERTED.CDPRODUTO,0)) AND
            (ISNULL(SETORPRODUTO.CDSETOR,0) = ISNULL(INSERTED.CDSETOR,0));
   END;
END;
GO

UPDATE SETORPRODUTO SET DTULTATU = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATU IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUSETORPROD' and
            type = 'D')
   ALTER TABLE SETORPRODUTO DROP CONSTRAINT DEFAULT_DTULTATUSETORPROD
GO

ALTER TABLE SETORPRODUTO ADD CONSTRAINT DEFAULT_DTULTATUSETORPROD
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATU
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_SETORPROD','5.85.XXX';
GO